import { __assign } from "./assign";
import { Observable } from "./rxjs-imports";
export { __assign };
export var jsonContentTypes = ["application/json", "application/vnd.api+json"];
export var apiRequest = function (url, options) {
    if (options === void 0) {
        options = {};
    }
    return Observable.ajax(__assign({ url: url }, options, { responseType: "json" })).map(function (res) {
        if (res.status >= 200 && res.status < 300) {
            if (res.status === 204) {
                return res;
            }
            var header_1 = res.xhr.getResponseHeader("Content-Type");
            if (typeof header_1 === "string" && jsonContentTypes.some(function (contentType) {
                return header_1.indexOf(contentType) > -1;
            })) {
                return res.response;
            }
        }
        return res;
    });
};
export var hasOwnProperties = function (obj, propertyTree) {
    if (obj instanceof Object === false) {
        return false;
    }
    var property = propertyTree[0];
    var hasProperty = obj.hasOwnProperty(property);
    if (hasProperty) {
        if (propertyTree.length === 1) {
            return hasProperty;
        }
        return hasOwnProperties(obj[property], propertyTree.slice(1));
    }
    return false;
};
export function find(array, predicate) {
    for (var i = 0; i < array.length; i += 1) {
        if (predicate(array[i], i, array)) {
            return array[i];
        }
    }
    return undefined;
}
export function findIndex(array, predicate) {
    if (array.length === 0) {
        return -1;
    }
    for (var i = 0; i < array.length; i++) {
        if (predicate(array[i], i, array)) {
            return i;
        }
    }
    return -1;
}
//# sourceMappingURL=utils.js.map